﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Text.RegularExpressions;

namespace SMSSClient
{
    // #####################################################################################
    // # TRIDA PROGRAM - konzolova aplikace Vema State Server Client                       #
    // # http://www.java2s.com/Code/CSharp/Network/SimpleTcpClient.htm			           #
    // #####################################################################################
    class Program
    {
        static void Main(string[] args)
        {
            // implicitni exit-code
            System.Environment.ExitCode = 1;

            // parser argumentu
            args_parser ap = new args_parser(args);

            // test nulovych argumentu
            /* if (args.Length == 0)
             {
                 PrintHelp();
                 return;
             }*/

            // nacteni parametru
            string ip = "127.0.0.1";    // defaultni IP adresa
            string arg_ip = ap.find_param("-a");
            string arg_command = ap.find_noparam();

            // test IP adresy 
            if (arg_ip.Length > 0)
            {
                if (Regex.Match(arg_ip, @"^(\d{1,3}\.){3}\d{1,3}$").Success)
                {
                    ip = arg_ip;
                }
                else
                {
                    Console.WriteLine("ERROR: Bad format of IP address.\n");
                    PrintHelp();
                    return;
                }
            }

            // test commandu
            if (arg_command.Length == 0)
            {
                Console.WriteLine("ERROR: Empty COMMAND.\n");
                PrintHelp();
                return;
            }

            // vytvoreni instance tridy pro sitovou komunikaci
            smsscomm vsscomm = new smsscomm();

            if (vsscomm.SMSSTalk(ip, arg_command))
            {
                System.Environment.ExitCode = 0;
                Console.WriteLine("OK: Successfully sent");
                return;
            }
            else
            {
                Console.WriteLine(vsscomm.err_message);
            }


        }







        // ---------------------------------------------------------------------------------
        // napise napovedu 
        // ---------------------------------------------------------------------------------
        static void PrintHelp()
        {
            Console.WriteLine("Usage: smsscl [-a ip_address] REQUEST\n");
            Console.WriteLine("REQUEST: #phone1;text1#phone2;tex2...#phonen;textn");
            Console.WriteLine("         Use international format only, eg. 420608337726\n");
            Console.WriteLine("Options: -a IP address of receiving SMS server (default 127.0.0.1)\n");
            Console.WriteLine("");
        }


    }
}
