﻿using System;
using System.Collections.Generic;
using System.Net;
using System.Net.Sockets;
using System.Linq;
using System.Text;
using System.Text.RegularExpressions;

namespace SMSSClient
{
    class smsscomm
    {

        public string err_message = "";

        // ---------------------------------------------------------------------------------
        // Funkce na pripojeni k TCP serveru s timeoutem
        // ---------------------------------------------------------------------------------
        public static Socket ConnectToserver(IPEndPoint endPoint, int timeoutMs)
        {
            Socket socket = new Socket(AddressFamily.InterNetwork, SocketType.Stream, ProtocolType.Tcp);
            try
            {
                socket.Blocking = false;
                socket.Connect(endPoint);
                return socket;
            }
            catch (SocketException socketException)
            {
                if (socketException.ErrorCode != 10035)
                {
                    socket.Close();
                    throw;
                }
                int timeoutMicroseconds = timeoutMs * 1000;
                if (socket.Poll(timeoutMicroseconds, SelectMode.SelectWrite) == false)
                {
                    socket.Close();
                    throw new Exception("The host failed to connect");
                }
                socket.Blocking = true;
                return socket;
            }
        }





        public bool SMSSTalk(string ip, string command)
        {
            IPEndPoint ipep = new IPEndPoint(IPAddress.Parse(ip), 2021);
            Socket socket = new Socket(AddressFamily.InterNetwork, SocketType.Stream, ProtocolType.Tcp);
            byte[] data = new byte[1024];
            string stringData;
            int recv;

            try
            {
                socket = ConnectToserver(ipep, 3000);
            }
            catch
            {
                err_message = "ERROR: Unable to connect";
                return (false);
            }

            try
            {
                socket.ReceiveTimeout = 2000;
                recv = socket.Receive(data);
                stringData = Encoding.ASCII.GetString(data, 0, recv);
                if (!Regex.Match(stringData, @"Vema SMS Server").Success)
                {
                    throw new Exception();
                }
            }
            catch
            {
                err_message = "ERROR: Not match Vema State Server in received header";
                return (false);
            }

            try
            {
                socket.SendTimeout = 2000;
                socket.Send(Encoding.ASCII.GetBytes(command + "\n"));
            }
            catch
            {
                err_message = "ERROR: Request sending error";
                return (false);
            }


            try
            {
                socket.ReceiveTimeout = 2000;
                recv = socket.Receive(data);
                stringData = Encoding.ASCII.GetString(data, 0, recv);
                if (!Regex.Match(stringData, @"Command\(s\) stored").Success)
                {
                    throw new Exception();
                }
            }
            catch
            {
                err_message = "ERROR: Request syntax error";
                return (false);
            }

            socket.Close();
            return (true);

        }



    }
}
